#!/usr/bin/env python

import sys
import os
import string
import types

from cdecl import *

tempname = "temp"
def mkheader(files):
  hfile = open( tempname+".h", "w" )
  header = open( "header.h" )
  hfile.write( header.read() )
  for filename in files:
    hfile.write( '#include "%s"\n'%filename )
  hfile.close()
  os.system( 'gcc -E %s.h > %s.E'%(tempname,tempname) )

def rmheader():
  os.unlink( tempname+".h" )
  os.unlink( tempname+".E" )

def log(*args):
  sys.stderr.write( string.join(map(str,args))+"\n" )

def harvest(files, verbose=0, test_parse=0, test_types=0, strip=0 ):
  flist = os.listdir('.')
  if filter(lambda x:x.startswith(tempname+"."),flist):
    raise Exception, "%s.* already exists"%tempname
  try:
    mkheader(files)
    f = open(tempname+".E")
    s = f.read()
    node = TransUnit(verbose = 1)
    sys.stderr.write( "# parsing...\n" )
    node.parse( s )
    if strip:
      node.strip(files)
    sys.stderr.write( "# processing...\n" )
    node.act(verbose,test_parse,test_types)
    #for decl in node:
      #decl.psource()
      #print decl.deepstr()
    return node
  finally:
    rmheader()

if __name__=="__main__":
  files = sys.argv[1:]
  if len(files)==0:
    # a test!
    stdclib = 'assert ctype errno limits setjmp signal stdio stdlib string time locale math '
    files = ['/usr/include/%s.h'%s for s in string.split(stdclib)]
    for f in files:
      print f
      harvest([f],1,1,1)
  else:
    harvest(files,1,1,1,1)



