##################################################
# const float * volatile s1;

Declaration(
  DeclarationSpecifiers(
    BasicType('float'),
    Qualifier('const')),
  Declarator(
    Identifier('s1'),
    Qualifier('volatile'),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('s1'),
    Qualifier('volatile'),
    Pointer(),
    DeclarationSpecifiers(
      BasicType('float'),
      Qualifier('const')))) 

# declarator.act()
Declarator(
  Identifier('s1'),
  Qualifier('volatile'),
  Pointer(),
  DeclarationSpecifiers(
    BasicType('float'),
    Qualifier('const'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('s1'),
  Qualifier('volatile'),
  Pointer(
    DeclarationSpecifiers(
      BasicType('float'),
      Qualifier('const')))) 

# const float *volatile s1;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Qualifier('volatile'),
  Pointer(
    DeclarationSpecifiers(
      BasicType('float'),
      Qualifier('const')))) 

# const float *volatile my_name;
##################################################
# int s2[][6];

Declaration(
  DeclarationSpecifiers(BasicType('int')),
  Declarator(
    Identifier('s2'),
    Array(),
    Array('6'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('s2'),
    Array(),
    Array('6'),
    DeclarationSpecifiers(BasicType('int')))) 

# declarator.act()
Declarator(
  Identifier('s2'),
  Array(),
  Array('6'),
  DeclarationSpecifiers(BasicType('int'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('s2'),
  Array(
    Array(
      DeclarationSpecifiers(BasicType('int')),
      '6'))) 

# int s2[][6];
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Array(
    Array(
      DeclarationSpecifiers(BasicType('int')),
      '6'))) 

# int my_name[][6];
##################################################
# int *s3[][];

Declaration(
  DeclarationSpecifiers(BasicType('int')),
  Declarator(
    Identifier('s3'),
    Array(),
    Array(),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('s3'),
    Array(),
    Array(),
    Pointer(),
    DeclarationSpecifiers(BasicType('int')))) 

# declarator.act()
Declarator(
  Identifier('s3'),
  Array(),
  Array(),
  Pointer(),
  DeclarationSpecifiers(BasicType('int'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('s3'),
  Array(
    Array(
      Pointer(DeclarationSpecifiers(BasicType('int')))))) 

# int *s3[][];
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Array(
    Array(
      Pointer(DeclarationSpecifiers(BasicType('int')))))) 

# int *my_name[][];
##################################################
# int (*s4[2])[];

Declaration(
  DeclarationSpecifiers(BasicType('int')),
  Declarator(
    Identifier('s4'),
    Array('2'),
    Pointer(),
    Array())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('s4'),
    Array('2'),
    Pointer(),
    Array(),
    DeclarationSpecifiers(BasicType('int')))) 

# declarator.act()
Declarator(
  Identifier('s4'),
  Array('2'),
  Pointer(),
  Array(),
  DeclarationSpecifiers(BasicType('int'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('s4'),
  Array(
    Pointer(
      Array(DeclarationSpecifiers(BasicType('int')))),
    '2')) 

# int (*s4[2])[];
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Array(
    Pointer(
      Array(DeclarationSpecifiers(BasicType('int')))),
    '2')) 

# int (*my_name[2])[];
##################################################
# int (*s41[2])(char);

Declaration(
  DeclarationSpecifiers(BasicType('int')),
  Declarator(
    Identifier('s41'),
    Array('2'),
    Pointer(),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('char')),
        AbstractDeclarator())))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('s41'),
    Array('2'),
    Pointer(),
    Function(
      AbstractDeclarator(TypeSpecifiers(BasicType('char')))),
    DeclarationSpecifiers(BasicType('int')))) 

# declarator.act()
Declarator(
  Identifier('s41'),
  Array('2'),
  Pointer(),
  Function(
    AbstractDeclarator(TypeSpecifiers(BasicType('char')))),
  DeclarationSpecifiers(BasicType('int'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('s41'),
  Array(
    Pointer(
      Function(
        AbstractDeclarator(TypeSpecifiers(BasicType('char'))),
        DeclarationSpecifiers(BasicType('int')))),
    '2')) 

# int (*s41[2])(char);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Array(
    Pointer(
      Function(
        AbstractDeclarator(
          Identifier(''),
          TypeSpecifiers(BasicType('char'))),
        DeclarationSpecifiers(BasicType('int')))),
    '2')) 

# int (*my_name[2])(char);
##################################################
# int (*s5[])[];

Declaration(
  DeclarationSpecifiers(BasicType('int')),
  Declarator(
    Identifier('s5'),
    Array(),
    Pointer(),
    Array())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('s5'),
    Array(),
    Pointer(),
    Array(),
    DeclarationSpecifiers(BasicType('int')))) 

# declarator.act()
Declarator(
  Identifier('s5'),
  Array(),
  Pointer(),
  Array(),
  DeclarationSpecifiers(BasicType('int'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('s5'),
  Array(
    Pointer(
      Array(DeclarationSpecifiers(BasicType('int')))))) 

# int (*s5[])[];
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Array(
    Pointer(
      Array(DeclarationSpecifiers(BasicType('int')))))) 

# int (*my_name[])[];
##################################################
# void f1();

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(Identifier('f1'),Function())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f1'),
    Function(),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('f1'),
  Function(),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f1'),
  Function(DeclarationSpecifiers(BasicType('void')))) 

# void f1();
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(DeclarationSpecifiers(BasicType('void')))) 

# void my_name();
##################################################
# const char * volatile f11();

Declaration(
  DeclarationSpecifiers(
    BasicType('char'),
    Qualifier('const')),
  Declarator(
    Identifier('f11'),
    Function(),
    Qualifier('volatile'),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f11'),
    Function(),
    Qualifier('volatile'),
    Pointer(),
    DeclarationSpecifiers(
      BasicType('char'),
      Qualifier('const')))) 

# declarator.act()
Declarator(
  Identifier('f11'),
  Function(),
  Qualifier('volatile'),
  Pointer(),
  DeclarationSpecifiers(
    BasicType('char'),
    Qualifier('const'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f11'),
  Function(
    Qualifier('volatile'),
    Pointer(
      DeclarationSpecifiers(
        BasicType('char'),
        Qualifier('const'))))) 

# const char *volatile f11();
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    Qualifier('volatile'),
    Pointer(
      DeclarationSpecifiers(
        BasicType('char'),
        Qualifier('const'))))) 

# const char *volatile my_name();
##################################################
# char * f12(unsigned int);

Declaration(
  DeclarationSpecifiers(BasicType('char')),
  Declarator(
    Identifier('f12'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(
          BasicType('int'),
          Qualifier('unsigned')),
        AbstractDeclarator())),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f12'),
    Function(
      AbstractDeclarator(
        TypeSpecifiers(
          BasicType('int'),
          Qualifier('unsigned')))),
    Pointer(),
    DeclarationSpecifiers(BasicType('char')))) 

# declarator.act()
Declarator(
  Identifier('f12'),
  Function(
    AbstractDeclarator(
      TypeSpecifiers(
        BasicType('int'),
        Qualifier('unsigned')))),
  Pointer(),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f12'),
  Function(
    AbstractDeclarator(
      TypeSpecifiers(
        BasicType('int'),
        Qualifier('unsigned'))),
    Pointer(DeclarationSpecifiers(BasicType('char'))))) 

# char *f12(unsigned int);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(
        BasicType('int'),
        Qualifier('unsigned'))),
    Pointer(DeclarationSpecifiers(BasicType('char'))))) 

# char *my_name(unsigned int);
##################################################
# char * f13(unsigned int zulu);

Declaration(
  DeclarationSpecifiers(BasicType('char')),
  Declarator(
    Identifier('f13'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(
          BasicType('int'),
          Qualifier('unsigned')),
        AbstractDeclarator(Identifier('zulu')))),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f13'),
    Function(
      AbstractDeclarator(
        Identifier('zulu'),
        TypeSpecifiers(
          BasicType('int'),
          Qualifier('unsigned')))),
    Pointer(),
    DeclarationSpecifiers(BasicType('char')))) 

# declarator.act()
Declarator(
  Identifier('f13'),
  Function(
    AbstractDeclarator(
      Identifier('zulu'),
      TypeSpecifiers(
        BasicType('int'),
        Qualifier('unsigned')))),
  Pointer(),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f13'),
  Function(
    AbstractDeclarator(
      Identifier('zulu'),
      TypeSpecifiers(
        BasicType('int'),
        Qualifier('unsigned'))),
    Pointer(DeclarationSpecifiers(BasicType('char'))))) 

# char *f13(unsigned int zulu);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(
        BasicType('int'),
        Qualifier('unsigned'))),
    Pointer(DeclarationSpecifiers(BasicType('char'))))) 

# char *my_name(unsigned int);
##################################################
# unsigned char f2(int **);

Declaration(
  DeclarationSpecifiers(
    BasicType('char'),
    Qualifier('unsigned')),
  Declarator(
    Identifier('f2'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator(Pointer(),Pointer()))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f2'),
    Function(
      AbstractDeclarator(
        Pointer(),
        Pointer(),
        TypeSpecifiers(BasicType('int')))),
    DeclarationSpecifiers(
      BasicType('char'),
      Qualifier('unsigned')))) 

# declarator.act()
Declarator(
  Identifier('f2'),
  Function(
    AbstractDeclarator(
      Pointer(),
      Pointer(),
      TypeSpecifiers(BasicType('int')))),
  DeclarationSpecifiers(
    BasicType('char'),
    Qualifier('unsigned'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f2'),
  Function(
    AbstractDeclarator(
      Pointer(
        Pointer(TypeSpecifiers(BasicType('int'))))),
    DeclarationSpecifiers(
      BasicType('char'),
      Qualifier('unsigned')))) 

# unsigned char f2(int **);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        Pointer(TypeSpecifiers(BasicType('int'))))),
    DeclarationSpecifiers(
      BasicType('char'),
      Qualifier('unsigned')))) 

# unsigned char my_name(int **);
##################################################
# void (*f3)(char);

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('f3'),
    Pointer(),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('char')),
        AbstractDeclarator())))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f3'),
    Pointer(),
    Function(
      AbstractDeclarator(TypeSpecifiers(BasicType('char')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('f3'),
  Pointer(),
  Function(
    AbstractDeclarator(TypeSpecifiers(BasicType('char')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f3'),
  Pointer(
    Function(
      AbstractDeclarator(TypeSpecifiers(BasicType('char'))),
      DeclarationSpecifiers(BasicType('void'))))) 

# void (*f3)(char);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Pointer(
    Function(
      AbstractDeclarator(
        Identifier(''),
        TypeSpecifiers(BasicType('char'))),
      DeclarationSpecifiers(BasicType('void'))))) 

# void (*my_name)(char);
##################################################
# void (*f4())(int);

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('f4'),
    Function(),
    Pointer(),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator())))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f4'),
    Function(),
    Pointer(),
    Function(
      AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('f4'),
  Function(),
  Pointer(),
  Function(
    AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f4'),
  Function(
    Pointer(
      Function(
        AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
        DeclarationSpecifiers(BasicType('void')))))) 

# void (*f4())(int);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    Pointer(
      Function(
        AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
        DeclarationSpecifiers(BasicType('void')))))) 

# void (*my_name())(int);
##################################################
# void (*(*f5)(void*))(int);
# 

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('f5'),
    Pointer(),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('void')),
        AbstractDeclarator(Pointer()))),
    Pointer(),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator())))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('f5'),
    Pointer(),
    Function(
      AbstractDeclarator(
        Pointer(),
        TypeSpecifiers(BasicType('void')))),
    Pointer(),
    Function(
      AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('f5'),
  Pointer(),
  Function(
    AbstractDeclarator(
      Pointer(),
      TypeSpecifiers(BasicType('void')))),
  Pointer(),
  Function(
    AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('f5'),
  Pointer(
    Function(
      AbstractDeclarator(
        Pointer(TypeSpecifiers(BasicType('void')))),
      Pointer(
        Function(
          AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
          DeclarationSpecifiers(BasicType('void'))))))) 

# void (*(*f5)(void *))(int);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Pointer(
    Function(
      AbstractDeclarator(
        Identifier(''),
        Pointer(TypeSpecifiers(BasicType('void')))),
      Pointer(
        Function(
          AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
          DeclarationSpecifiers(BasicType('void'))))))) 

# void (*(*my_name)(void *))(int);
##################################################
# struct spam;

Declaration(
  DeclarationSpecifiers(Struct(Tag('spam'))),
  Declarator()) 

# declaration.act()
Declaration(
  Declarator(
    DeclarationSpecifiers(Struct(Tag('spam'))))) 

# declarator.act()
Declarator(
  DeclarationSpecifiers(Struct(Tag('spam')))) 

# rw.visit_decl(declarator)
Declarator(
  DeclarationSpecifiers(Struct(Tag('spam')))) 

# struct spam;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Struct(Tag('spam')))) 

# struct spam my_name;
##################################################
# struct baz;
# 

Declaration(
  DeclarationSpecifiers(Struct(Tag('baz'))),
  Declarator()) 

# declaration.act()
Declaration(
  Declarator(
    DeclarationSpecifiers(Struct(Tag('baz'))))) 

# declarator.act()
Declarator(
  DeclarationSpecifiers(Struct(Tag('baz')))) 

# rw.visit_decl(declarator)
Declarator(
  DeclarationSpecifiers(Struct(Tag('baz')))) 

# struct baz;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Struct(Tag('baz')))) 

# struct baz my_name;
##################################################
# struct spam2 { struct spam spam; };
# 

Declaration(
  DeclarationSpecifiers(
    Struct(
      Tag('spam2'),
      StructDeclaration(
        DeclarationSpecifiers(Struct(Tag('spam'))),
        StructDeclarator(Identifier('spam'))))),
  Declarator()) 

# declaration.act()
Declaration(
  Declarator(
    DeclarationSpecifiers(
      Struct(
        Tag('spam2'),
        StructDeclarator(
          Identifier('spam'),
          DeclarationSpecifiers(Struct(Tag('spam')))))))) 

# declarator.act()
Declarator(
  DeclarationSpecifiers(
    Struct(
      Tag('spam2'),
      StructDeclarator(
        Identifier('spam'),
        DeclarationSpecifiers(Struct(Tag('spam'))))))) 

# rw.visit_decl(declarator)
Declarator(
  DeclarationSpecifiers(
    Struct(
      Tag('spam2'),
      StructDeclarator(
        Identifier('spam'),
        DeclarationSpecifiers(Struct(Tag('spam'))))))) 

# struct spam2 
# {
# struct spam spam;
# };
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Struct(Tag('spam2')))) 

# struct spam2 my_name;
##################################################
# struct spam
# {
#   float ham[3];
#   float eggs[9];
#   struct baz* bacon;
# } some_spam;

Declaration(
  DeclarationSpecifiers(
    Struct(
      Tag('spam'),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('float')),
        StructDeclarator(
          Identifier('ham'),
          Array('3'))),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('float')),
        StructDeclarator(
          Identifier('eggs'),
          Array('9'))),
      StructDeclaration(
        DeclarationSpecifiers(Struct(Tag('baz'))),
        StructDeclarator(Identifier('bacon'),Pointer())))),
  Declarator(Identifier('some_spam'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('some_spam'),
    DeclarationSpecifiers(
      Struct(
        Tag('spam'),
        StructDeclarator(
          Identifier('ham'),
          Array('3'),
          DeclarationSpecifiers(BasicType('float'))),
        StructDeclarator(
          Identifier('eggs'),
          Array('9'),
          DeclarationSpecifiers(BasicType('float'))),
        StructDeclarator(
          Identifier('bacon'),
          Pointer(),
          DeclarationSpecifiers(Struct(Tag('baz')))))))) 

# declarator.act()
Declarator(
  Identifier('some_spam'),
  DeclarationSpecifiers(
    Struct(
      Tag('spam'),
      StructDeclarator(
        Identifier('ham'),
        Array('3'),
        DeclarationSpecifiers(BasicType('float'))),
      StructDeclarator(
        Identifier('eggs'),
        Array('9'),
        DeclarationSpecifiers(BasicType('float'))),
      StructDeclarator(
        Identifier('bacon'),
        Pointer(),
        DeclarationSpecifiers(Struct(Tag('baz'))))))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('some_spam'),
  DeclarationSpecifiers(
    Struct(
      Tag('spam'),
      StructDeclarator(
        Identifier('ham'),
        Array(
          DeclarationSpecifiers(BasicType('float')),
          '3')),
      StructDeclarator(
        Identifier('eggs'),
        Array(
          DeclarationSpecifiers(BasicType('float')),
          '9')),
      StructDeclarator(
        Identifier('bacon'),
        Pointer(
          DeclarationSpecifiers(Struct(Tag('baz')))))))) 

# struct spam 
# {
# float ham[3];
# float eggs[9];
# struct baz *bacon;
# } some_spam;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Struct(Tag('spam')))) 

# struct spam my_name;
##################################################
# char spam, maps, psam(), *(*samp)();

Declaration(
  DeclarationSpecifiers(BasicType('char')),
  Declarator(Identifier('spam')),
  Declarator(Identifier('maps')),
  Declarator(Identifier('psam'),Function()),
  Declarator(
    Identifier('samp'),
    Pointer(),
    Function(),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('spam'),
    DeclarationSpecifiers(BasicType('char'))),
  Declarator(
    Identifier('maps'),
    DeclarationSpecifiers(BasicType('char'))),
  Declarator(
    Identifier('psam'),
    Function(),
    DeclarationSpecifiers(BasicType('char'))),
  Declarator(
    Identifier('samp'),
    Pointer(),
    Function(),
    Pointer(),
    DeclarationSpecifiers(BasicType('char')))) 

# declarator.act()
Declarator(
  Identifier('spam'),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('spam'),
  DeclarationSpecifiers(BasicType('char'))) 

# char spam;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(BasicType('char'))) 

# char my_name;
# declarator.act()
Declarator(
  Identifier('maps'),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('maps'),
  DeclarationSpecifiers(BasicType('char'))) 

# char maps;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(BasicType('char'))) 

# char my_name;
# declarator.act()
Declarator(
  Identifier('psam'),
  Function(),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('psam'),
  Function(DeclarationSpecifiers(BasicType('char')))) 

# char psam();
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(DeclarationSpecifiers(BasicType('char')))) 

# char my_name();
# declarator.act()
Declarator(
  Identifier('samp'),
  Pointer(),
  Function(),
  Pointer(),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('samp'),
  Pointer(
    Function(
      Pointer(DeclarationSpecifiers(BasicType('char')))))) 

# char *(*samp)();
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Pointer(
    Function(
      Pointer(DeclarationSpecifiers(BasicType('char')))))) 

# char *(*my_name)();
##################################################
# struct spam*make_some();

Declaration(
  DeclarationSpecifiers(Struct(Tag('spam'))),
  Declarator(
    Identifier('make_some'),
    Function(),
    Pointer())) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('make_some'),
    Function(),
    Pointer(),
    DeclarationSpecifiers(Struct(Tag('spam'))))) 

# declarator.act()
Declarator(
  Identifier('make_some'),
  Function(),
  Pointer(),
  DeclarationSpecifiers(Struct(Tag('spam')))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('make_some'),
  Function(
    Pointer(
      DeclarationSpecifiers(Struct(Tag('spam')))))) 

# struct spam *make_some();
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    Pointer(
      DeclarationSpecifiers(Struct(Tag('spam')))))) 

# struct spam *my_name();
##################################################
# unsigned int typedef uint_t;

Declaration(
  DeclarationSpecifiers(
    Typedef('typedef'),
    BasicType('int'),
    Qualifier('unsigned')),
  Declarator(Identifier('uint_t'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('uint_t'),
    DeclarationSpecifiers(
      Typedef('typedef'),
      BasicType('int'),
      Qualifier('unsigned')))) 

# declarator.act()
Declarator(
  Identifier('uint_t'),
  DeclarationSpecifiers(
    Typedef('typedef'),
    BasicType('int'),
    Qualifier('unsigned'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('uint_t'),
  DeclarationSpecifiers(
    Typedef('typedef'),
    BasicType('int'),
    Qualifier('unsigned'))) 

# unsigned int typedef uint_t;
# 
# rmtypedef(uint_t)
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(
    Typedef('typedef'),
    BasicType('int'),
    Qualifier('unsigned'))) 

# unsigned int typedef my_name;
##################################################
# uint_t x;

Declaration(
  DeclarationSpecifiers(TypeAlias('uint_t')),
  Declarator(Identifier('x'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('x'),
    DeclarationSpecifiers(TypeAlias('uint_t')))) 

# declarator.act()
Declarator(
  Identifier('x'),
  DeclarationSpecifiers(TypeAlias('uint_t'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('x'),
  DeclarationSpecifiers(TypeAlias('uint_t'))) 

# uint_t x;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(TypeAlias('uint_t'))) 

# uint_t my_name;
##################################################
# typedef int at;

Declaration(
  DeclarationSpecifiers(
    BasicType('int'),
    Typedef('typedef')),
  Declarator(Identifier('at'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('at'),
    DeclarationSpecifiers(
      BasicType('int'),
      Typedef('typedef')))) 

# declarator.act()
Declarator(
  Identifier('at'),
  DeclarationSpecifiers(
    BasicType('int'),
    Typedef('typedef'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('at'),
  DeclarationSpecifiers(
    BasicType('int'),
    Typedef('typedef'))) 

# typedef int at;
# 
# rmtypedef(at)
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(
    BasicType('int'),
    Typedef('typedef'))) 

# typedef int my_name;
##################################################
# typedef at bt;

Declaration(
  DeclarationSpecifiers(
    TypeAlias('at'),
    Typedef('typedef')),
  Declarator(Identifier('bt'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('bt'),
    DeclarationSpecifiers(
      TypeAlias('at'),
      Typedef('typedef')))) 

# declarator.act()
Declarator(
  Identifier('bt'),
  DeclarationSpecifiers(
    TypeAlias('at'),
    Typedef('typedef'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('bt'),
  DeclarationSpecifiers(
    TypeAlias('at'),
    Typedef('typedef'))) 

# typedef at bt;
# 
# rmtypedef(bt)
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(
    TypeAlias('at'),
    Typedef('typedef'))) 

# typedef at my_name;
##################################################
# unsigned bt c;
# 

Declaration(
  DeclarationSpecifiers(
    TypeAlias('bt'),
    Qualifier('unsigned')),
  Declarator(Identifier('c'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('c'),
    DeclarationSpecifiers(
      TypeAlias('bt'),
      Qualifier('unsigned')))) 

# declarator.act()
Declarator(
  Identifier('c'),
  DeclarationSpecifiers(
    TypeAlias('bt'),
    Qualifier('unsigned'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('c'),
  DeclarationSpecifiers(
    TypeAlias('bt'),
    Qualifier('unsigned'))) 

# unsigned bt c;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(
    TypeAlias('bt'),
    Qualifier('unsigned'))) 

# unsigned bt my_name;
##################################################
# typedef struct { char baz; } baz_t; baz_t i_am_a_baz;

Declaration(
  DeclarationSpecifiers(
    Struct(
      Tag(),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('char')),
        StructDeclarator(Identifier('baz')))),
    Typedef('typedef')),
  Declarator(Identifier('baz_t'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('baz_t'),
    DeclarationSpecifiers(
      Struct(
        Tag(),
        StructDeclarator(
          Identifier('baz'),
          DeclarationSpecifiers(BasicType('char')))),
      Typedef('typedef')))) 

# declarator.act()
Declarator(
  Identifier('baz_t'),
  DeclarationSpecifiers(
    Struct(
      Tag(),
      StructDeclarator(
        Identifier('baz'),
        DeclarationSpecifiers(BasicType('char')))),
    Typedef('typedef'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('baz_t'),
  DeclarationSpecifiers(
    Struct(
      Tag(),
      StructDeclarator(
        Identifier('baz'),
        DeclarationSpecifiers(BasicType('char')))),
    Typedef('typedef'))) 

# typedef struct 
# {
# char baz;
# } baz_t;
# 
# rmtypedef(baz_t)
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(
    Struct(
      Tag(),
      StructDeclarator(
        Identifier('baz'),
        DeclarationSpecifiers(BasicType('char')))),
    Typedef('typedef'))) 

# typedef struct 
# {
# char baz;
# } my_name;
##################################################
# typedef struct { char baz; } baz_t; baz_t i_am_a_baz;
# 

Declaration(
  DeclarationSpecifiers(TypeAlias('baz_t')),
  Declarator(Identifier('i_am_a_baz'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('i_am_a_baz'),
    DeclarationSpecifiers(TypeAlias('baz_t')))) 

# declarator.act()
Declarator(
  Identifier('i_am_a_baz'),
  DeclarationSpecifiers(TypeAlias('baz_t'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('i_am_a_baz'),
  DeclarationSpecifiers(TypeAlias('baz_t'))) 

# baz_t i_am_a_baz;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(TypeAlias('baz_t'))) 

# baz_t my_name;
##################################################
# union u_tag
# {
#   int a;
#   char b;
# };
# 

Declaration(
  DeclarationSpecifiers(
    Union(
      Tag('u_tag'),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('int')),
        StructDeclarator(Identifier('a'))),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('char')),
        StructDeclarator(Identifier('b'))))),
  Declarator()) 

# declaration.act()
Declaration(
  Declarator(
    DeclarationSpecifiers(
      Union(
        Tag('u_tag'),
        StructDeclarator(
          Identifier('a'),
          DeclarationSpecifiers(BasicType('int'))),
        StructDeclarator(
          Identifier('b'),
          DeclarationSpecifiers(BasicType('char'))))))) 

# declarator.act()
Declarator(
  DeclarationSpecifiers(
    Union(
      Tag('u_tag'),
      StructDeclarator(
        Identifier('a'),
        DeclarationSpecifiers(BasicType('int'))),
      StructDeclarator(
        Identifier('b'),
        DeclarationSpecifiers(BasicType('char')))))) 

# rw.visit_decl(declarator)
Declarator(
  DeclarationSpecifiers(
    Union(
      Tag('u_tag'),
      StructDeclarator(
        Identifier('a'),
        DeclarationSpecifiers(BasicType('int'))),
      StructDeclarator(
        Identifier('b'),
        DeclarationSpecifiers(BasicType('char')))))) 

# union u_tag 
# {
# int a;
# char b;
# };
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Union(Tag('u_tag')))) 

# union u_tag my_name;
##################################################
# void
# foo(struct baz*c);
# 

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('foo'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('baz'))),
        AbstractDeclarator(Identifier('c'),Pointer()))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('foo'),
    Function(
      AbstractDeclarator(
        Identifier('c'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('baz'))))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('foo'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('baz'))))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('foo'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    DeclarationSpecifiers(BasicType('void')))) 

# void foo(struct baz *c);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    DeclarationSpecifiers(BasicType('void')))) 

# void my_name(struct baz *);
##################################################
# void bar( struct baz*c, struct spam*ii, int n);
# 

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('bar'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('baz'))),
        AbstractDeclarator(Identifier('c'),Pointer())),
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('spam'))),
        AbstractDeclarator(Identifier('ii'),Pointer())),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator(Identifier('n')))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('bar'),
    Function(
      AbstractDeclarator(
        Identifier('c'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('baz')))),
      AbstractDeclarator(
        Identifier('ii'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('spam')))),
      AbstractDeclarator(
        Identifier('n'),
        TypeSpecifiers(BasicType('int')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('bar'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('baz')))),
    AbstractDeclarator(
      Identifier('ii'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('spam')))),
    AbstractDeclarator(
      Identifier('n'),
      TypeSpecifiers(BasicType('int')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('bar'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier('ii'),
      Pointer(
        TypeSpecifiers(Struct(Tag('spam'))))),
    AbstractDeclarator(
      Identifier('n'),
      TypeSpecifiers(BasicType('int'))),
    DeclarationSpecifiers(BasicType('void')))) 

# void bar(struct baz *c,struct spam *ii,int n);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('spam'))))),
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(BasicType('int'))),
    DeclarationSpecifiers(BasicType('void')))) 

# void my_name(struct baz *,struct spam *,int);
##################################################
# struct packed { int a:3; int :0; int c:9; };
# 

Declaration(
  DeclarationSpecifiers(
    Struct(
      Tag('packed'),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('int')),
        StructDeclarator(
          Identifier('a'),
          FieldLength(3))),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('int')),
        StructDeclarator(FieldLength(0))),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('int')),
        StructDeclarator(
          Identifier('c'),
          FieldLength(9))))),
  Declarator()) 

# declaration.act()
Declaration(
  Declarator(
    DeclarationSpecifiers(
      Struct(
        Tag('packed'),
        StructDeclarator(
          Identifier('a'),
          FieldLength(3),
          DeclarationSpecifiers(BasicType('int'))),
        StructDeclarator(
          FieldLength(0),
          DeclarationSpecifiers(BasicType('int'))),
        StructDeclarator(
          Identifier('c'),
          FieldLength(9),
          DeclarationSpecifiers(BasicType('int'))))))) 

# declarator.act()
Declarator(
  DeclarationSpecifiers(
    Struct(
      Tag('packed'),
      StructDeclarator(
        Identifier('a'),
        FieldLength(3),
        DeclarationSpecifiers(BasicType('int'))),
      StructDeclarator(
        FieldLength(0),
        DeclarationSpecifiers(BasicType('int'))),
      StructDeclarator(
        Identifier('c'),
        FieldLength(9),
        DeclarationSpecifiers(BasicType('int')))))) 

# rw.visit_decl(declarator)
Declarator(
  DeclarationSpecifiers(
    Struct(
      Tag('packed'),
      StructDeclarator(
        Identifier('a'),
        FieldLength(3),
        DeclarationSpecifiers(BasicType('int'))),
      StructDeclarator(
        FieldLength(0),
        DeclarationSpecifiers(BasicType('int'))),
      StructDeclarator(
        Identifier('c'),
        FieldLength(9),
        DeclarationSpecifiers(BasicType('int')))))) 

# struct packed 
# {
# int a:3;
# int :0;
# int c:9;
# };
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Struct(Tag('packed')))) 

# struct packed my_name;
##################################################
# enum enum_tag { number1 = 1, number2, number77 } x1, x2;
# 

Declaration(
  DeclarationSpecifiers(
    Enum(
      Tag('enum_tag'),
      Identifier('number1',1),
      Identifier('number2'),
      Identifier('number77'))),
  Declarator(Identifier('x1')),
  Declarator(Identifier('x2'))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('x1'),
    DeclarationSpecifiers(
      Enum(
        Tag('enum_tag'),
        Identifier('number1',1),
        Identifier('number2'),
        Identifier('number77')))),
  Declarator(
    Identifier('x2'),
    DeclarationSpecifiers(
      Enum(
        Tag('enum_tag'),
        Identifier('number1',1),
        Identifier('number2'),
        Identifier('number77'))))) 

# declarator.act()
Declarator(
  Identifier('x1'),
  DeclarationSpecifiers(
    Enum(
      Tag('enum_tag'),
      Identifier('number1',1),
      Identifier('number2'),
      Identifier('number77')))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('x1'),
  DeclarationSpecifiers(
    Enum(
      Tag('enum_tag'),
      Identifier('number1',1),
      Identifier('number2'),
      Identifier('number77')))) 

# enum enum_tag 
# {
# number1 = 1,
# number2,
# number77,
# } x1;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Enum(Tag('enum_tag')))) 

# enum enum_tag my_name;
# declarator.act()
Declarator(
  Identifier('x2'),
  DeclarationSpecifiers(
    Enum(
      Tag('enum_tag'),
      Identifier('number1',1),
      Identifier('number2'),
      Identifier('number77')))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('x2'),
  DeclarationSpecifiers(
    Enum(
      Tag('enum_tag'),
      Identifier('number1',1),
      Identifier('number2'),
      Identifier('number77')))) 

# enum enum_tag 
# {
# number1 = 1,
# number2,
# number77,
# } x2;
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Enum(Tag('enum_tag')))) 

# enum enum_tag my_name;
##################################################
# void
# foobar( struct baz*c, float*f, float*g );
# 

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('foobar'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('baz'))),
        AbstractDeclarator(Identifier('c'),Pointer())),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('float')),
        AbstractDeclarator(Identifier('f'),Pointer())),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('float')),
        AbstractDeclarator(Identifier('g'),Pointer()))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('foobar'),
    Function(
      AbstractDeclarator(
        Identifier('c'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('baz')))),
      AbstractDeclarator(
        Identifier('f'),
        Pointer(),
        TypeSpecifiers(BasicType('float'))),
      AbstractDeclarator(
        Identifier('g'),
        Pointer(),
        TypeSpecifiers(BasicType('float')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('foobar'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('baz')))),
    AbstractDeclarator(
      Identifier('f'),
      Pointer(),
      TypeSpecifiers(BasicType('float'))),
    AbstractDeclarator(
      Identifier('g'),
      Pointer(),
      TypeSpecifiers(BasicType('float')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('foobar'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier('f'),
      Pointer(TypeSpecifiers(BasicType('float')))),
    AbstractDeclarator(
      Identifier('g'),
      Pointer(TypeSpecifiers(BasicType('float')))),
    DeclarationSpecifiers(BasicType('void')))) 

# void foobar(struct baz *c,float *f,float *g);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier(''),
      Pointer(TypeSpecifiers(BasicType('float')))),
    AbstractDeclarator(
      Identifier(''),
      Pointer(TypeSpecifiers(BasicType('float')))),
    DeclarationSpecifiers(BasicType('void')))) 

# void my_name(struct baz *,float *,float *);
##################################################
# char
# func1( char a, struct baz *c);
# 

Declaration(
  DeclarationSpecifiers(BasicType('char')),
  Declarator(
    Identifier('func1'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('char')),
        AbstractDeclarator(Identifier('a'))),
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('baz'))),
        AbstractDeclarator(Identifier('c'),Pointer()))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('func1'),
    Function(
      AbstractDeclarator(
        Identifier('a'),
        TypeSpecifiers(BasicType('char'))),
      AbstractDeclarator(
        Identifier('c'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('baz'))))),
    DeclarationSpecifiers(BasicType('char')))) 

# declarator.act()
Declarator(
  Identifier('func1'),
  Function(
    AbstractDeclarator(
      Identifier('a'),
      TypeSpecifiers(BasicType('char'))),
    AbstractDeclarator(
      Identifier('c'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('baz'))))),
  DeclarationSpecifiers(BasicType('char'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('func1'),
  Function(
    AbstractDeclarator(
      Identifier('a'),
      TypeSpecifiers(BasicType('char'))),
    AbstractDeclarator(
      Identifier('c'),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    DeclarationSpecifiers(BasicType('char')))) 

# char func1(char a,struct baz *c);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(BasicType('char'))),
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    DeclarationSpecifiers(BasicType('char')))) 

# char my_name(char,struct baz *);
##################################################
# struct ll
# {
#   struct baz*c;
#   struct ll*next;
#   void (*v)(struct ll*p_ll);
#   float s;
# };
# 

Declaration(
  DeclarationSpecifiers(
    Struct(
      Tag('ll'),
      StructDeclaration(
        DeclarationSpecifiers(Struct(Tag('baz'))),
        StructDeclarator(Identifier('c'),Pointer())),
      StructDeclaration(
        DeclarationSpecifiers(Struct(Tag('ll'))),
        StructDeclarator(Identifier('next'),Pointer())),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('void')),
        StructDeclarator(
          Identifier('v'),
          Pointer(),
          Function(
            ParameterDeclaration(
              TypeSpecifiers(Struct(Tag('ll'))),
              AbstractDeclarator(Identifier('p_ll'),Pointer()))))),
      StructDeclaration(
        DeclarationSpecifiers(BasicType('float')),
        StructDeclarator(Identifier('s'))))),
  Declarator()) 

# declaration.act()
Declaration(
  Declarator(
    DeclarationSpecifiers(
      Struct(
        Tag('ll'),
        StructDeclarator(
          Identifier('c'),
          Pointer(),
          DeclarationSpecifiers(Struct(Tag('baz')))),
        StructDeclarator(
          Identifier('next'),
          Pointer(),
          DeclarationSpecifiers(Struct(Tag('ll')))),
        StructDeclarator(
          Identifier('v'),
          Pointer(),
          Function(
            AbstractDeclarator(
              Identifier('p_ll'),
              Pointer(),
              TypeSpecifiers(Struct(Tag('ll'))))),
          DeclarationSpecifiers(BasicType('void'))),
        StructDeclarator(
          Identifier('s'),
          DeclarationSpecifiers(BasicType('float'))))))) 

# declarator.act()
Declarator(
  DeclarationSpecifiers(
    Struct(
      Tag('ll'),
      StructDeclarator(
        Identifier('c'),
        Pointer(),
        DeclarationSpecifiers(Struct(Tag('baz')))),
      StructDeclarator(
        Identifier('next'),
        Pointer(),
        DeclarationSpecifiers(Struct(Tag('ll')))),
      StructDeclarator(
        Identifier('v'),
        Pointer(),
        Function(
          AbstractDeclarator(
            Identifier('p_ll'),
            Pointer(),
            TypeSpecifiers(Struct(Tag('ll'))))),
        DeclarationSpecifiers(BasicType('void'))),
      StructDeclarator(
        Identifier('s'),
        DeclarationSpecifiers(BasicType('float')))))) 

# rw.visit_decl(declarator)
Declarator(
  DeclarationSpecifiers(
    Struct(
      Tag('ll'),
      StructDeclarator(
        Identifier('c'),
        Pointer(
          DeclarationSpecifiers(Struct(Tag('baz'))))),
      StructDeclarator(
        Identifier('next'),
        Pointer(
          DeclarationSpecifiers(Struct(Tag('ll'))))),
      StructDeclarator(
        Identifier('v'),
        Pointer(
          Function(
            AbstractDeclarator(
              Identifier('p_ll'),
              Pointer(
                TypeSpecifiers(Struct(Tag('ll'))))),
            DeclarationSpecifiers(BasicType('void'))))),
      StructDeclarator(
        Identifier('s'),
        DeclarationSpecifiers(BasicType('float')))))) 

# struct ll 
# {
# struct baz *c;
# struct ll *next;
# void (*v)(struct ll *p_ll);
# float s;
# };
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  DeclarationSpecifiers(Struct(Tag('ll')))) 

# struct ll my_name;
##################################################
# void
# bazbar(struct baz*c,int x,int y,int z);

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('bazbar'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('baz'))),
        AbstractDeclarator(Identifier('c'),Pointer())),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator(Identifier('x'))),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator(Identifier('y'))),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator(Identifier('z')))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('bazbar'),
    Function(
      AbstractDeclarator(
        Identifier('c'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('baz')))),
      AbstractDeclarator(
        Identifier('x'),
        TypeSpecifiers(BasicType('int'))),
      AbstractDeclarator(
        Identifier('y'),
        TypeSpecifiers(BasicType('int'))),
      AbstractDeclarator(
        Identifier('z'),
        TypeSpecifiers(BasicType('int')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('bazbar'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('baz')))),
    AbstractDeclarator(
      Identifier('x'),
      TypeSpecifiers(BasicType('int'))),
    AbstractDeclarator(
      Identifier('y'),
      TypeSpecifiers(BasicType('int'))),
    AbstractDeclarator(
      Identifier('z'),
      TypeSpecifiers(BasicType('int')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('bazbar'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier('x'),
      TypeSpecifiers(BasicType('int'))),
    AbstractDeclarator(
      Identifier('y'),
      TypeSpecifiers(BasicType('int'))),
    AbstractDeclarator(
      Identifier('z'),
      TypeSpecifiers(BasicType('int'))),
    DeclarationSpecifiers(BasicType('void')))) 

# void bazbar(struct baz *c,int x,int y,int z);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(BasicType('int'))),
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(BasicType('int'))),
    AbstractDeclarator(
      Identifier(''),
      TypeSpecifiers(BasicType('int'))),
    DeclarationSpecifiers(BasicType('void')))) 

# void my_name(struct baz *,int,int,int);
##################################################
# void
# barbaz(struct baz*c,float x[3]);
# 

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('barbaz'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(Struct(Tag('baz'))),
        AbstractDeclarator(Identifier('c'),Pointer())),
      ParameterDeclaration(
        TypeSpecifiers(BasicType('float')),
        AbstractDeclarator(
          Identifier('x'),
          Array('3')))))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('barbaz'),
    Function(
      AbstractDeclarator(
        Identifier('c'),
        Pointer(),
        TypeSpecifiers(Struct(Tag('baz')))),
      AbstractDeclarator(
        Identifier('x'),
        Array('3'),
        TypeSpecifiers(BasicType('float')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('barbaz'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(),
      TypeSpecifiers(Struct(Tag('baz')))),
    AbstractDeclarator(
      Identifier('x'),
      Array('3'),
      TypeSpecifiers(BasicType('float')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('barbaz'),
  Function(
    AbstractDeclarator(
      Identifier('c'),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier('x'),
      Array(
        TypeSpecifiers(BasicType('float')),
        '3')),
    DeclarationSpecifiers(BasicType('void')))) 

# void barbaz(struct baz *c,float x[3]);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        TypeSpecifiers(Struct(Tag('baz'))))),
    AbstractDeclarator(
      Identifier(''),
      Array(
        TypeSpecifiers(BasicType('float')),
        '3')),
    DeclarationSpecifiers(BasicType('void')))) 

# void my_name(struct baz *,float [3]);
##################################################
# void ( *signal( void(*)(int) ) )(int);

Declaration(
  DeclarationSpecifiers(BasicType('void')),
  Declarator(
    Identifier('signal'),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('void')),
        AbstractDeclarator(
          Pointer(),
          Function(
            ParameterDeclaration(
              TypeSpecifiers(BasicType('int')),
              AbstractDeclarator()))))),
    Pointer(),
    Function(
      ParameterDeclaration(
        TypeSpecifiers(BasicType('int')),
        AbstractDeclarator())))) 

# declaration.act()
Declaration(
  Declarator(
    Identifier('signal'),
    Function(
      AbstractDeclarator(
        Pointer(),
        Function(
          AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
        TypeSpecifiers(BasicType('void')))),
    Pointer(),
    Function(
      AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
    DeclarationSpecifiers(BasicType('void')))) 

# declarator.act()
Declarator(
  Identifier('signal'),
  Function(
    AbstractDeclarator(
      Pointer(),
      Function(
        AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
      TypeSpecifiers(BasicType('void')))),
  Pointer(),
  Function(
    AbstractDeclarator(TypeSpecifiers(BasicType('int')))),
  DeclarationSpecifiers(BasicType('void'))) 

# rw.visit_decl(declarator)
Declarator(
  Identifier('signal'),
  Function(
    AbstractDeclarator(
      Pointer(
        Function(
          AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
          TypeSpecifiers(BasicType('void'))))),
    Pointer(
      Function(
        AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
        DeclarationSpecifiers(BasicType('void')))))) 

# void (*signal(void (*)(int)))(int);
# 
# OK

# declarator.ctype() 
Declarator(
  Identifier(''),
  Function(
    AbstractDeclarator(
      Identifier(''),
      Pointer(
        Function(
          AbstractDeclarator(
            Identifier(''),
            TypeSpecifiers(BasicType('int'))),
          TypeSpecifiers(BasicType('void'))))),
    Pointer(
      Function(
        AbstractDeclarator(TypeSpecifiers(BasicType('int'))),
        DeclarationSpecifiers(BasicType('void')))))) 

# void (*my_name(void (*)(int)))(int);
